## digikam 2.2.0

=== CMakeLists.txt ===
# ===========================================================
#
# This file is a part of digiKam project
# <a href="http://www.digikam.org">http://www.digikam.org</a>
#
# @date   2010-12-11
# @brief  digiKam Software Collection
#
# @author Copyright (C) 2010-2011 by Gilles Caulier
#         <a href="mailto:caulier dot gilles at gmail dot com">caulier dot gilles at gmail dot com</a>
#
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General
# Public License as published by the Free Software Foundation;
# either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# ============================================================

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(digikam-sc)

IF(KDE4_BUILD_TESTS)
    INCLUDE(CTest)
    ENABLE_TESTING()
ENDIF(KDE4_BUILD_TESTS)
FIND_PACKAGE(KDE4 REQUIRED)

# Added for the po/ folder 
set_property(GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS 1)

# If building for KDE<4.6.95, we need to build some parts of KDE-graphics
# by ourselves, because we depend on newer versions. If you want
# to force building of these libraries, specify -DDIGIKAMSC_USE_PRIVATE_KDEGRAPHICS:BOOL=1
# as an argument to CMake.
IF(NOT DEFINED DIGIKAMSC_USE_PRIVATE_KDEGRAPHICS)
    IF(${KDE_VERSION} VERSION_LESS "4.6.95")
        SET(DIGIKAMSC_USE_PRIVATE_KDEGRAPHICS 1)
    ELSE()
        SET(DIGIKAMSC_USE_PRIVATE_KDEGRAPHICS 0)
    ENDIF()
ENDIF()

# Make sure that the FindXXX modules of the local libraries are found
IF(${DIGIKAMSC_USE_PRIVATE_KDEGRAPHICS})
    # prepend our own FindXXX modules to CMAKE_MODULE_PATH
    SET(CMAKE_MODULE_PATH
            ${CMAKE_SOURCE_DIR}/extra/libkexiv2/cmake/modules
            ${CMAKE_SOURCE_DIR}/extra/libkdcraw/cmake/modules
            ${CMAKE_MODULE_PATH}
        )
ENDIF()

# prepend our own FindXXX modules to CMAKE_MODULE_PATH
SET(CMAKE_MODULE_PATH
        ${CMAKE_SOURCE_DIR}/extra/libkgeomap/cmake/modules
        ${CMAKE_SOURCE_DIR}/extra/libmediawiki/cmake/modules
        ${CMAKE_SOURCE_DIR}/extra/libkface/cmake/modules
        ${CMAKE_SOURCE_DIR}/extra/libkvkontakte/cmake/modules
        ${CMAKE_SOURCE_DIR}/cmake/modules
        ${CMAKE_MODULE_PATH}
    )

IF(${DIGIKAMSC_USE_PRIVATE_KDEGRAPHICS})
    SET(KIPI_LOCAL_DIR extra/libkipi)
    SET(KEXIV2_LOCAL_DIR extra/libkexiv2)
    SET(KDCRAW_LOCAL_DIR extra/libkdcraw)
    SET(KSANE_LOCAL_DIR extra/libksane)
ENDIF()

SET(KFACE_LOCAL_DIR extra/libkface)
SET(KGEOMAP_LOCAL_DIR extra/libkgeomap)
SET(MEDIAWIKI_LOCAL_DIR extra/libmediawiki)
SET(LIBKVKONTAKTE_LOCAL_DIR extra/libkvkontakte)

ADD_SUBDIRECTORY(extra)
ADD_SUBDIRECTORY(core)
ADD_SUBDIRECTORY(doc)

find_package(Msgfmt REQUIRED)
find_package(Gettext REQUIRED)
add_subdirectory( po )

=== core/CMakeLists.txt ===

PROJECT(digikam)

MESSAGE(STATUS "----------------------------------------------------------------------------------")
MESSAGE(STATUS "Starting CMake configuration for: digikam")

OPTION(ENABLE_SCRIPTIFACE      "Build digiKam with experimental scripting support (default=OFF)" OFF)
OPTION(ENABLE_THUMBS_DB        "Build digiKam with thumbnails database support (default=ON)"     ON)
OPTION(ENABLE_INTERNALMYSQL    "Look for MySQL server executable at build time (default=ON)"     ON)
OPTION(ENABLE_ADVANCEDDEBUGMSG "Build digiKam with more internal debug message (default=OFF)"    OFF)
OPTION(ENABLE_NEPOMUKSUPPORT   "Build digiKam with Nepomuk support (default=ON)"                 ON)

# ==================================================================================================
# Information to update before to release this package.

# digiKam version
SET(DIGIKAM_MAJOR_VERSION "2")
SET(DIGIKAM_MINOR_VERSION "2")
SET(DIGIKAM_PATCH_VERSION "0")

#digiKam release date
SET(DIGIKAM_RELEASE_DATE "2011-10-02")

# Suffix to add at end of version string. Usual values are:
# "-git"   : alpha code unstable from git. Do not use in production
# "-beta1" : beta1 release.
# "-beta2" : beta2 release.
# "-beta3" : beta3 release.
# "-rc"    : release candidate.
# ""       : final release. Can be used in production.
SET(DIGIKAM_SUFFIX_VERSION "")

# ==================================================================================================
# Set env. variables accordingly.

SET(DIGIKAM_VERSION_SHORT
    "${DIGIKAM_MAJOR_VERSION}.${DIGIKAM_MINOR_VERSION}.${DIGIKAM_PATCH_VERSION}"
   )

SET(DIGIKAM_VERSION_STRING
    "${DIGIKAM_VERSION_SHORT}${DIGIKAM_SUFFIX_VERSION}"
   )

# Path to find FindPGF.cmake script.
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

# ==================================================================================================
# Debug area codes
# These codes will be set for every project specific path automatically, so
# that you can use kDebug() without any usage of the area code throughout the
# digiKam code base.
SET(AREA_CODE_GENERAL        "50003")
SET(AREA_CODE_KIOSLAVES      "50004")
SET(AREA_CODE_SHOWFOTO       "50005")
SET(AREA_CODE_IMAGEPLUGINS   "50006")
SET(AREA_CODE_DATABASESERVER "50007")
ADD_DEFINITIONS(-DKDE_DEFAULT_DEBUG_AREA=${AREA_CODE_GENERAL})
ADD_DEFINITIONS(-DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)

MACRO(SET_DEBUG_AREA_CODE _areacode)
    REMOVE_DEFINITIONS(-DKDE_DEFAULT_DEBUG_AREA=${AREA_CODE_GENERAL})
    ADD_DEFINITIONS(-DKDE_DEFAULT_DEBUG_AREA=${_areacode})
ENDMACRO(SET_DEBUG_AREA_CODE)

# =======================================================
# some useful macros for printing status information

SET(PRINT_COMPILE_LENGTH "40")
MACRO(FILL_WITH_DOTS VAR)

    STRING(LENGTH ${${VAR}} NAME_LENGTH)

    MATH(EXPR DOT_LENGTH "${PRINT_COMPILE_LENGTH} - ${NAME_LENGTH}")
    IF(${DOT_LENGTH} LESS 0)
        SET(DOT_LENGTH 0)
    ENDIF(${DOT_LENGTH} LESS 0)

    FOREACH(COUNT RANGE ${DOT_LENGTH})
        SET(${VAR} "${${VAR}}.")
    ENDFOREACH(COUNT)

ENDMACRO(FILL_WITH_DOTS)

MACRO(PRINT_LIBRARY_STATUS NAME WEBSITE VERSIONHINT)

    SET(LIB_MESSAGE "${NAME} library found")
    FILL_WITH_DOTS(LIB_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} YES")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} NO")
        MESSAGE(STATUS "")
        MESSAGE(SEND_ERROR " digiKam needs ${NAME}. You need to install the ${NAME}${VERSIONHINT} library development package.")
        MESSAGE(STATUS " ${NAME} website is at ${WEBSITE}")
        MESSAGE(STATUS "")
    ENDIF(${ARGN})

ENDMACRO(PRINT_LIBRARY_STATUS)

MACRO(PRINT_QTMODULE_STATUS NAME)

    SET(LIB_MESSAGE "${NAME} module found")
    FILL_WITH_DOTS(LIB_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} YES")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} NO")
        MESSAGE(STATUS "")
        MESSAGE(SEND_ERROR " digiKam needs ${NAME} module. You need to install a package containing the ${NAME} module.")
        MESSAGE(STATUS "")
    ENDIF(${ARGN})

ENDMACRO(PRINT_QTMODULE_STATUS)

MACRO(PRINT_EXECUTABLE_STATUS NAME TECHNICAL_NAME PATH_VARIABLE)

    SET(LIB_MESSAGE "${NAME} found")
    FILL_WITH_DOTS(LIB_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} YES")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} NO")
        MESSAGE(STATUS "")
        MESSAGE(STATUS " digiKam needs ${NAME}. You need to install the package containing the \"${TECHNICAL_NAME}\" executable.")
        MESSAGE(STATUS " If you have this executable installed, please specify the folder containing it by ${PATH_VARIABLE}")
        MESSAGE(SEND_ERROR "")
    ENDIF(${ARGN})

ENDMACRO(PRINT_EXECUTABLE_STATUS)

# ==================================================================================================
# Dependencies

FIND_PACKAGE(KDE4 REQUIRED)
INCLUDE(KDE4Defaults)
INCLUDE(MacroLibrary)

INCLUDE(FindPackageHandleStandardArgs)
SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH} )

FIND_PACKAGE(LCMS)
FIND_PACKAGE(JPEG)
FIND_PACKAGE(PNG)
FIND_PACKAGE(TIFF)
FIND_PACKAGE(Jasper)
FIND_PACKAGE(Kdcraw)
FIND_PACKAGE(Kexiv2)
FIND_PACKAGE(Kipi)
FIND_PACKAGE(Kface)
FIND_PACKAGE(KGeoMap)
FIND_PACKAGE(PGF)
FIND_PACKAGE(CLAPACK)
FIND_PACKAGE(Boost) # 1.36.0)

IF(Boost_FOUND)
    INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
ENDIF(Boost_FOUND)

#-------------------------------------------------------------------------------------

MACRO_BOOL_TO_01(PGF_FOUND USE_EXT_LIBPGF)

# NOTE: currently libpgf 6.11.24 do not support very well OpenMP. We disable it temporally.
# See B.K.O #273765 for details.
ADD_DEFINITIONS(-DLIBPGF_DISABLE_OPENMP)

# LibPGF need to be linked to OpenMP if necessary.
# OpenMP detection (requires CMake >= 2.6.3)
# NOTE: OpenMP under MacOSX do not support multithreading.

IF(NOT APPLE AND NOT USE_EXT_LIBPGF)
    MACRO_OPTIONAL_FIND_PACKAGE(OpenMP)

    IF(OPENMP_FOUND)
        # OpenMP defintions ${OpenMP_CXX_FLAGS} is set on right digiKam components through sub-cmake scripts.
        IF("${OpenMP_CXX_FLAGS}" STREQUAL "-fopenmp" )
            SET(OPENMP_LDFLAGS "-lgomp")
        ENDIF("${OpenMP_CXX_FLAGS}" STREQUAL "-fopenmp" )
        IF("${OpenMP_CXX_FLAGS}" STREQUAL "-xopenmp" )
            SET(OPENMP_LDFLAGS "-xopenmp")
        ENDIF("${OpenMP_CXX_FLAGS}" STREQUAL "-xopenmp" )
    ENDIF(OPENMP_FOUND)
ENDIF(NOT APPLE AND NOT USE_EXT_LIBPGF)

#-------------------------------------------------------------------------------------

IF(NOT APPLE)
    MACRO_BOOL_TO_01(CLAPACK_FOUND USE_EXT_LIBCLAPACK)
ELSE(NOT APPLE)
    # Under MACOS-X Clapack exist in standard, but it's not suitable as well. Need investiguation here.
    SET(CLAPACK_FOUND FALSE)
ENDIF(NOT APPLE)

#-------------------------------------------------------------------------------------

# check version of libjpeg so that we can use the appropriate dir
# See bug #227313
SET(_jpeglib_version_source "#include <stddef.h>\n#include<stdio.h>\n#include <jpeglib.h>\n int main()\n {\n #if (JPEG_LIB_VERSION >= 80) \n #error JPEG_LIB_VERSION >= 80 found \n #endif \n }\n")
SET(_jpeglib_version_source_file ${CMAKE_BINARY_DIR}/CMakeTmp/cmake_jpeglib_version_check.cpp)
FILE(WRITE "${_jpeglib_version_source_file}" "${_jpeglib_version_source}")
SET(_jpeglib_version_include_dirs "-DINCLUDE_DIRECTORIES:STRING=${JPEG_INCLUDE_DIR}")

TRY_COMPILE(_jpeglib_version_compile_result ${CMAKE_BINARY_DIR} ${_jpeglib_version_source_file}
            CMAKE_FLAGS "${_jpeglib_version_include_dirs}"
            COMPILE_OUTPUT_VARIABLE _jpeglib_version_compile_output_var)

IF(_jpeglib_version_compile_result)
    MESSAGE(STATUS "Identified libjpeg version: 62")
    SET(DIGIKAM_LIBJPEG_DIR libjpeg-62)
ELSE(_jpeglib_version_compile_result)
    MESSAGE(STATUS "Identified libjpeg version: 80+")
    SET(DIGIKAM_LIBJPEG_DIR libjpeg-80)
ENDIF(_jpeglib_version_compile_result)

#-------------------------------------------------------------------------------------

IF (ENABLE_INTERNALMYSQL)
# Check MySQL executables
    FIND_PROGRAM( SERVERCMD_MYSQL mysqld
                  PATHS /usr/sbin /usr/local/sbin /usr/libexec /usr/local/libexec /opt/local/libexec
                        /opt/mysql/libexec /usr/mysql/bin /opt/mysql/sbin ${MYSQLD_PATH}
                        ENV MYSQLD_PATH )
    MESSAGE(STATUS "Found MySQL server executable at: ${SERVERCMD_MYSQL}")

# NOTE: under windows, mysql_install_db PERL script is named "mysql_install_db.pl"
#       under MACOS-X, through macports project, mysql_install_db PERL script is named "mysql_install_db5"
    FIND_PROGRAM( INITCMD_MYSQL mysql_install_db mysql_install_db5 mysql_install_db.pl
                  PATHS /usr/sbin /usr/local/sbin /usr/libexec /usr/local/libexec
                        /opt/mysql/libexec /usr/mysql/bin /opt/mysql/bin ${MYSQL_TOOLS_PATH}
                       ENV MYSQL_TOOLS_PATH )
    MESSAGE(STATUS "Found MySQL install_db executable at: ${INITCMD_MYSQL}")
    SET(DATABASESERVERDIR "${CMAKE_CURRENT_SOURCE_DIR}/databaseserver")
ELSE (ENABLE_INTERNALMYSQL)
    SET(DATABASESERVERDIR "")
ENDIF (ENABLE_INTERNALMYSQL)
MACRO_BOOL_TO_01(ENABLE_INTERNALMYSQL HAVE_INTERNALMYSQL)

# check the libkdcraw version
# note that old versions don't specify version information, so for now
# just inform the user if version information was found
SET(KDCRAW_MIN_VERSION "2.0.0")
IF (KDCRAW_VERSION)
  MESSAGE(STATUS "libkdcraw: Found version ${KDCRAW_VERSION} (required: ${KDCRAW_MIN_VERSION})")
  IF (${KDCRAW_VERSION} VERSION_LESS ${KDCRAW_MIN_VERSION})
    SET(KDCRAW_FOUND FALSE)
  ENDIF (${KDCRAW_VERSION} VERSION_LESS ${KDCRAW_MIN_VERSION})
ELSE (KDCRAW_VERSION)
  MESSAGE(WARNING "libkdcraw: Version information not found, your version is probably too old.")
ENDIF (KDCRAW_VERSION)

# check the libkgeomap version
# note that old versions don't specify version information, so for now
# just inform the user if version information was found
IF (KGEOMAP_VERSION)
  MESSAGE(STATUS "libkgeomap: Found version ${KGEOMAP_VERSION}")
  # TODO: fail if the version is too low
ENDIF (KGEOMAP_VERSION)

# ==================================================================================================
# Optional dependencies

MACRO_OPTIONAL_FIND_PACKAGE(Gphoto2)
MACRO_BOOL_TO_01(GPHOTO2_FOUND HAVE_GPHOTO2)

IF (NOT WIN32 AND HAVE_GPHOTO2)
    # See B.K.O #268267 : digiKam need to be linked to libusb to prevent crash at gphoto2 init if opencv is linked with libdc1394
    MACRO_OPTIONAL_FIND_PACKAGE(USB)
ENDIF (NOT WIN32 AND HAVE_GPHOTO2)

MACRO_OPTIONAL_FIND_PACKAGE(KdepimLibs)
MACRO_BOOL_TO_01(KDEPIMLIBS_FOUND HAVE_KDEPIMLIBS)

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH} )

# Check GLib2 library for lrqr-1 and lensfun libraries.
MACRO_OPTIONAL_FIND_PACKAGE(GLIB2)
MACRO_BOOL_TO_01(GLIB2_FOUND HAVE_GLIB2)

# Check LensFun library for Lens auto-correction tool.
MACRO_OPTIONAL_FIND_PACKAGE(LensFun)
MACRO_BOOL_TO_01(LENSFUN_FOUND USE_EXT_LIBLENSFUN)

# Check Lqr-1 library for Contents Aware Resizer tool.
MACRO_OPTIONAL_FIND_PACKAGE(Lqr-1)
MACRO_BOOL_TO_01(LQR-1_FOUND USE_EXT_LIBLQR-1)

MACRO_BOOL_TO_01(ENABLE_SCRIPTIFACE USE_SCRIPT_IFACE)
MACRO_BOOL_TO_01(ENABLE_THUMBS_DB USE_THUMBS_DB)
MACRO_BOOL_TO_01(ENABLE_ADVANCEDDEBUGMSG USE_ADVANCEDDEBUGMSG)

# Win32 compilation with Nepomuk is broken. It's temporally disabled.
IF (ENABLE_NEPOMUKSUPPORT)
    IF (${KDE_VERSION} VERSION_GREATER "4.3.99")
        MACRO_OPTIONAL_FIND_PACKAGE(Nepomuk)
        MACRO_LOG_FEATURE(NEPOMUK_FOUND "Nepomuk" "The Nepomuk libraries"
                "http://www.kde.org" FALSE "" "Nepomuk extends the search and tagging")

        MACRO_OPTIONAL_FIND_PACKAGE(SharedDesktopOntologies 0.2)
        MACRO_LOG_FEATURE(SHAREDDESKTOPONTOLOGIES_FOUND "Shared desktop ontologies" "Desktop ontologies"
            "http://oscaf.sourceforge.net" TRUE "0.2" "Ontologies necessary for the Nepomuk semantic desktop.")

=== po/hsb/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( hsb ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} ${_po_files} )

=== core/data/pics/CMakeLists.txt ===
ADD_SUBDIRECTORY(borderpatterns)
ADD_SUBDIRECTORY(texturepatterns)

# digiKam files ######################################################

INSTALL(FILES tag.png
              tag-new.png
              tag-properties.png
              tag-delete.png
              tag-reset.png
              tag-folder.png
              tag-events.png
              tag-people.png
              tag-places.png
              tag-addressbook.png
              tag-recents.png
              tag-assigned.png
              albumfolder-importimages.png
              albumfolder-properties.png
              albumfolder-new.png
              albumfolder-importdir.png
              underexposure.png
              overexposure.png
        DESTINATION ${DATA_INSTALL_DIR}/digikam/icons/hicolor/32x32/actions
       )

INSTALL(FILES splash-digikam.png
              banner-digikam.png
              logo-digikam.png
              logo-gphoto.png
              logo-lcms.png
              logo-exiv2.png
              logo-cimg.png
              image-full.png
              image-selection.png
              histogram-lin.png
              histogram-log.png
              centerwidth.png
              centerheight.png
              target.png
              bothvert.png
              bothhorz.png
              curvefree.png
              curvemooth.png
              original.png
              duplicatebothvert.png
              duplicatebothhorz.png
              togglemouseover.png
              assistant-collection.png
              assistant-rawimport.png
              assistant-tooltips.png
              assistant-metadata.png
              assistant-preview.png
              assistant-openfile.png
              assistant-scancollection.png
              colors-luma.png
              colors-chromablue.png
              colors-chromared.png
              sample-aix.png
         DESTINATION ${DATA_INSTALL_DIR}/digikam/data
       )

# Showfoto files ######################################################

INSTALL(FILES logo-showfoto.png
              banner-showfoto.png
              splash-showfoto.png
        DESTINATION ${DATA_INSTALL_DIR}/showfoto/data
       )

=== extra/kipi-plugins/jpeglossless/CMakeLists.txt ===
SUBDIRS(icons)

# enable final triggers: http://bugs.kde.org/show_bug.cgi?id=126326
# digikam: camera download: auto-rotated images loose EXIF info ...
# So make sure nofinal is always used here!
KDE4_NO_ENABLE_FINAL(kipiplugin_jpeglossless)

INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}/libjpeg
                    ${CMAKE_CURRENT_SOURCE_DIR}/transform
                    ${CMAKE_CURRENT_SOURCE_DIR}/plugin
                   )

SET(kipiplugin_jpeglossless_PART_SRCS plugin/plugin_jpeglossless.cpp 
                                      plugin/utils.cpp 
                                      plugin/actionthread.cpp
                                      transform/jpegtransform.cpp 
                                      transform/imagerotate.cpp 
                                      transform/convert2grayscale.cpp 
                                      transform/imageflip.cpp 
                                      libjpeg/transupp.cpp 
   )

KDE4_ADD_PLUGIN(kipiplugin_jpeglossless ${kipiplugin_jpeglossless_PART_SRCS})

IF(WIN32)
    SET_TARGET_PROPERTIES( kipiplugin_jpeglossless PROPERTIES COMPILE_FLAGS -DJPEG_STATIC )
ENDIF(WIN32)

TARGET_LINK_LIBRARIES(kipiplugin_jpeglossless
                      ${KDE4_KPARTS_LIBS}
                      ${QT_AND_KDECORE_LIBS}
                      ${KIPI_LIBRARIES}
                      ${KEXIV2_LIBRARIES}
                      ${KDCRAW_LIBRARIES}
                      ${JPEG_LIBRARY}
                      kipiplugins
                     )

INSTALL(TARGETS kipiplugin_jpeglossless DESTINATION ${PLUGIN_INSTALL_DIR})
INSTALL(FILES plugin/kipiplugin_jpeglossless.desktop DESTINATION ${SERVICES_INSTALL_DIR})

=== extra/kipi-plugins/shwup/CMakeLists.txt ===
SUBDIRS(icons)

SET(kipiplugin_shwup_PART_SRCS
    plugin_shwup.cpp
    swwindow.cpp
    swlogin.cpp
    swalbum.cpp
    swconnector.cpp
    swwidget.cpp
   )

KDE4_ADD_PLUGIN(kipiplugin_shwup ${kipiplugin_shwup_PART_SRCS})

TARGET_LINK_LIBRARIES(kipiplugin_shwup
                      ${KIPI_LIBRARIES}
                      ${KEXIV2_LIBRARIES}
                      ${KDCRAW_LIBRARIES}
                      ${QCA2_LIBRARIES}
                      ${KDE4_KIO_LIBS}
                      ${KDE4_KDEUI_LIBS}
                      kipiplugins
                     )

INCLUDE_DIRECTORIES(
    ${QCA2_INCLUDE_DIR}
    )

ADD_DEFINITIONS(
    ${QCA2_DEFINITIONS}
    )

INSTALL(TARGETS kipiplugin_shwup DESTINATION ${PLUGIN_INSTALL_DIR})
INSTALL(FILES kipiplugin_shwup.desktop DESTINATION ${SERVICES_INSTALL_DIR})

=== extra/libkvkontakte/libkvkontakte/CMakeLists.txt ===
set(libkvkontakte_SRCS
    authenticationdialog.cpp
    userinfojob.cpp
    userinfo.cpp
    friendlistjob.cpp
    photojob.cpp
    noteslistjob.cpp
    allnoteslistjob.cpp
    notejob.cpp
    getvariablejob.cpp
    userinfofulljob.cpp
    cidsnamesjob.cpp
    getinfojob.cpp
    messageinfo.cpp
    discussionslistjob.cpp
    messageslistjob.cpp
    noteinfo.cpp
    noteaddjob.cpp
    allmessageslistjob.cpp
    albumlistjob.cpp
    albuminfo.cpp
    createalbumjob.cpp
    editalbumjob.cpp
    deletealbumjob.cpp
    getphotouploadserverjob.cpp
    photopostjob.cpp
    mpform.cpp
    savephotojob.cpp
    uploadphotosjob.cpp
    photoinfo.cpp
    photolistjob.cpp
    getapplicationpermissionsjob.cpp
    getuploadserverjobbase.cpp
    getprofilephotouploadserverjob.cpp
    getwallphotouploadserverjob.cpp
    groupinfo.cpp
    grouplistjob.cpp

    qintlist.cpp
    util.cpp
    vkontaktejobs.cpp  
)

kde4_add_library(kvkontakte SHARED ${libkvkontakte_SRCS})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/version.h)

# Yes, QJSON_LIBRARIES and QJSON_LIBRARY are both needed, as otherwise it will break either
# on Linux or on Mac.
target_link_libraries(kvkontakte
  ${KDE4_KDECORE_LIBS}
  ${KDE4_KDEUI_LIBS}
  ${QT_QTGUI_LIBRARY}
  ${QT_QTWEBKIT_LIBRARY}
  ${KDE4_KDEWEBKIT_LIBS}
  ${KDE4_KIO_LIBS}
  ${QJSON_LIBRARIES}
  ${QJSON_LIBRARY}
  ${KDEPIMLIBS_KABC_LIBS}
  ${KDEPIMLIBS_KPIMUTILS_LIBS}
  ${KDEPIMLIBS_KMIME_LIBS}
)

set_target_properties(kvkontakte
	PROPERTIES
	VERSION ${LIBKVKONTAKTE_VERSION}
	SOVERSION ${LIBKVKONTAKTE_VERSION_MAJOR})

install(TARGETS kvkontakte
	EXPORT LibKVkontakteExport
	${INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/version.h
    libkvkontakte_export.h
    albuminfo.h
    getapplicationpermissionsjob.h
    vkontaktejobs.h
    authenticationdialog.h
    albumlistjob.h
    qintlist.h
    createalbumjob.h
    editalbumjob.h
    uploadphotosjob.h
    photoinfo.h
    userinfo.h
    messageinfo.h
    noteinfo.h
    friendlistjob.h
    allnoteslistjob.h
    userinfofulljob.h
    userinfojob.h
    photojob.h
    noteslistjob.h
    notejob.h
    noteaddjob.h
    allmessageslistjob.h
    messageslistjob.h
    discussionslistjob.h
    getvariablejob.h
    deletealbumjob.h
    cidsnamesjob.h
    getinfojob.h
    photolistjob.h
    groupinfo.h
    grouplistjob.h
    DESTINATION ${INCLUDE_INSTALL_DIR}/libkvkontakte COMPONENT Devel)

=== extra/kipi-plugins/dngconverter/test/CMakeLists.txt ===

# =======================================================
# DNGVALIDATE tool from DNG SDK

SET(dngvalidate_SRCS ../dngwriter/extra/dng_sdk/dng_validate.cpp)

KDE4_ADD_EXECUTABLE(dngvalidate NOGUI ${dngvalidate_SRCS})

TARGET_LINK_LIBRARIES(dngvalidate libdng ${CMAKE_THREAD_LIBS_INIT})

# =======================================================
# RAW2DNG command line tool

SET(raw2dng_SRCS raw2dng.cpp)

KDE4_ADD_EXECUTABLE(raw2dng NOGUI
                    ${libdngwriter_SRCS}
                    ${raw2dng_SRCS}
                   )

TARGET_LINK_LIBRARIES(raw2dng
                      ${KDE4_KDECORE_LIBS}
                      ${KDE4_KIO_LIBS}
                      ${QT_AND_KDECORE_LIBS}
                      ${QT_LIBRARIES}
                      ${KEXIV2_LIBRARIES}
                      ${KDCRAW_LIBRARIES}
                      ${CMAKE_THREAD_LIBS_INIT}
                      libdng
                     )

=== extra/libmediawiki/samplecode/editsample/CMakeLists.txt ===
PROJECT( editSample )

KDE4_ADD_UI_FILES (ui_src mainwindow.ui)

SET(editSample_SRCS
    main.cpp
    mainwindow.cpp
   )

KDE4_ADD_EXECUTABLE( editSample ${editSample_SRCS} ${ui_src} )
TARGET_LINK_LIBRARIES( editSample ${KDE4_KIO_LIBS} mediawiki)

=== extra/libmediawiki/samplecode/uploadsample/CMakeLists.txt ===
PROJECT( uploadSample )
KDE4_ADD_UI_FILES (ui_src mainwindow.ui)

SET(uploadSample_SRCS
    main.cpp
    mainwindow.cpp
   )

KDE4_ADD_EXECUTABLE( uploadSample ${uploadSample_SRCS} ${ui_src} )
TARGET_LINK_LIBRARIES( uploadSample ${KDE4_KIO_LIBS} mediawiki)

=== extra/kipi-plugins/photolayoutseditor/borderplugins/polaroid/CMakeLists.txt ===
SET(photolayoutseditorborderplugin_polaroid_SRCS
         PolaroidBorderDrawer.cpp
         PolaroidBorderDrawer_p.cpp
   )

KDE4_ADD_PLUGIN(photolayoutseditorborderplugin_polaroid ${photolayoutseditorborderplugin_polaroid_SRCS})

TARGET_LINK_LIBRARIES(
    photolayoutseditorborderplugin_polaroid
    libphotolayoutseditor
    ${KDE4_KDECORE_LIBS}
    ${KDE4_KDEUI_LIBS}
    ${QT_QTCORE_LIBRARY}
    ${QT_QTGUI_LIBRARY}
    )

INSTALL(TARGETS photolayoutseditorborderplugin_polaroid DESTINATION ${PLUGIN_INSTALL_DIR})
INSTALL(FILES photolayoutseditorborderplugin_polaroid.desktop DESTINATION ${SERVICES_INSTALL_DIR})

=== debian/changelog ===
digikam (2:2.2.0-1) experimental; urgency=low

  * New upstream release
    - Fixes "new upstream version: 2.0" (Closes: #628019)
  * Upstream have now merged the following packages:
    - digikam, digikam-doc, kipi-plugins
  * Add Build-Depends: chrpath, libboost-graph-dev, libcv-dev (>= 2.2) - experimental
  * Add patches/highgui_c.h to account for different layout
  * Add chrpath to strip binary-or-shlib-defines-rpath
  * lintian-overrides embedded-library reported upstream:
      https://bugs.kde.org/show_bug.cgi?id=237037
  * Add relevant files to debian/digikam.docs
  * Update debian/control Description:

  * digikam 2.0.0 uses features from kdegraphics 4.7 & ships a private 
  version of the kdegraphics libs - this is not the Debian way :-(
  * Unsatisfactory Conflicts: libkexiv2-dev kipi-plugins-common libkdcraw-dev
  libkipi-dev kdegraphics-libs-data & libkipi8

 -- Mark Purcell <msp@debian.org>  Fri, 07 Oct 2011 22:30:40 +1100

digikam (2:1.9.0-3) unstable; urgency=low

  * Upload to unstable
    - Fixes "digikam crashes after splash screen" (Closes: #605452)

 -- Mark Purcell <msp@debian.org>  Sat, 28 May 2011 17:53:30 +1000

digikam (2:1.9.0-2) experimental; urgency=low

  * Rebuild against experimental KDE SC 4.6.2
    - Fixes "Experimental: uninstallable" (Closes: #620676)
    - Fixes "Experimental: digikam and showfoto don't start" (Closes: #620873)
  * Added Recommends: mplayerthumbs (Closes: #622266)

 -- Mark Purcell <msp@debian.org>  Sun, 08 May 2011 10:47:46 +1000

=== debian/control ===
Source: digikam
Section: graphics
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Achim Bohnet <ach@mpe.mpg.de>, Mark Purcell <msp@debian.org>, Fathi Boudra <fabo@debian.org>
Build-Depends: debhelper (>= 8), pkg-kde-tools (>= 0.9), pkg-config, cmake (>= 2.6.2), autotools-dev, chrpath,
 doxygen,
 kdelibs5-dev (>= 4:4.4.4), kdepimlibs5-dev,
 libqt4-dev, libqt4-opengl-dev, libgl1-mesa-dev, libglu1-mesa-dev,
 libgphoto2-2-dev,
 libgtk2.0-dev,
 libxslt1-dev | libxslt-dev, libxml2-dev,
 libgpod-nogtk-dev,
 libqca2-dev,
 libqjson-dev,
 libltdl3-dev, libpng-dev, libtiff4-dev, libjpeg-dev,
 libsane-dev,
 shared-desktop-ontologies,
 mysql-server-5.1 | mysql-server,
 libglib2.0-dev, libgphoto2-2-dev (>= 2.4),
 libmarble-dev (>= 4:4.5),
 liblcms1-dev, libtiff4-dev, libpng12-dev, liblqr-1-0-dev,
 libcv-dev (>= 2.2), libcvaux-dev (>= 2.2), libopencv-contrib-dev (>= 2.2), libopencv-gpu-dev (>= 2.2),
 libjasper-dev,
 liblensfun-dev,
 libexiv2-dev (>= 0.21),
 libsqlite3-dev,
 libboost-graph-dev,
 libx11-dev, libxrandr-dev, libexpat1-dev | libexpat-dev
# Digikam 2.x ships kdegraphics as a private library as it uses KDE SC 4.7 components
Build-Conflicts: libkipi-dev, libkexiv2-dev (>= 4:4.5), libkdcraw-dev (>= 4:4.5), libksane-dev
Standards-Version: 3.8.4
Vcs-Svn: svn://svn.debian.org/pkg-kde/kde-extras/digikam/trunk
Vcs-Browser: http://svn.debian.org/wsvn/pkg-kde/kde-extras/digikam/trunk?op=log
Homepage: http://www.digikam.org

Package: digikam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt4-sql-sqlite, digikam-data (= ${source:Version})
Recommends: www-browser, kipi-plugins, mplayerthumbs
Conflicts: libkexiv2-dev, libkdcraw-dev, libkipi-dev, kdegraphics-libs-data
Suggests: digikam-doc
Description: digital photo management application for KDE
 Digital photo management program designed to import, organize, enhance, search
 and export your digital images to and from your computer.
 .
 It provides a simple interface which makes importing and organizing digital
 photographs a "snap". digiKam enables you to manage large numbers of
 digital photographs in Albums and to organize these photographs for easy
 retrieval using tags (keywords), captions, collections, dates, geolocation
 and searches. It has many features for viewing, organizing, processing and
 sharing your images. Thus, digiKam is a formidable Digital Asset Management
 (DAM) software including powerful image editing functions. 
 .
 An easy-to-use Camera interface is provided, that will connect to your
 digital camera and download photographs directly into digiKam Albums.
 More than 1000 digital cameras are supported by the gphoto2 library.
 Of course, any media or card reader supported by your operating system
 will interface with digiKam. 
 .
 digiKam incorporates a fast Image Editor with many image editing tools.
 You can use the Image Editor to view your photographs, comment and rate
 them, correct, enhance and alter them. The editing power can be easily
 extended by a set of plugins, the Kde Image Plugins Interface (manual) 
 .
 While digiKam remains easy to use, it provides professional level features
 by the dozens. It is fully 16 bit enabled including all available plugins,
 supports RAW format conversion through libraw, DNG export and ICC color
 management work flow. 
 .
 New Features of the KDE4 version:
  Runs on any platform that supports Qt4 and KDE4 (including Win32 and OS X)
  Supports XMP metadata
  Reads, writes and converts into DNG format
  New RAW processing tool, gamma-correction in 16 bits
  Preview of video and audio files
  Database file is independent of photo libraries, enabling remote paths, multiple roots and offline archives
  Improved database with many more metadata that can be searched, e.g. camera or lens
  Marble integration, geographical filtering with the mouse on the map
  New search finds duplicates and similar images
  Help menu lists all RAW formats and digiKam component versions
  DNG, RWL, NEF and PEF RAW file can be metadata edited
  Usability improvements for netbooks
  Non-modal image editor
  Thumbnail bar in preview mode
  Live search boxes in both sidebars and main window
  New camera interface, capture tool, scanner interface
  New plugin based on lensfun for automatic lens error corrections
 .
 digiKam can also make use of the KIPI image handling plugins to
 extend its capabilities even further for photo manipulations,
 import and export, etc. The kipi-plugins package contains many
 very useful extentions.

Package: showfoto
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, digikam (= ${binary:Version})
Recommends: dolphin, kipi-plugins
Description: image viewer/editor for KDE
 Showphoto is the standalone image editor of the  digiKam project.
 .
 It runs without digiKam images database support, but provides all Image Editor
 functions.

Package: digikam-dbg
Architecture: any
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends}, digikam (= ${binary:Version}), showfoto (= ${binary:Version}), kdelibs5-dbg
Priority: extra
Description: debugging symbols for digikam
 The debugging symbols associated with digikam and showfoto. They will
 automatically be used by gdb for debugging digikam-related issues.

Package: digikam-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: digikam architecture-independant data
 Contains the significant amount of architecture-independent data that is
 shipped with digikam.
 .
 It has been placed in an architecture all file so we do not have
 to ship one copy for each architecture.

Package: digikam-doc
Architecture: all
Depends: ${misc:Depends}, khelpcenter4
Recommends: digikam
Description: handbook for digikam and showfoto in several languages
 Digikam is an easy to use and powerful digital photo management
 application.
 .
 This package contains the handbooks for digikam, showfoto and
 kipi-plugins from the digikam package.

Package: kipi-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, kipi-plugins-common (= ${source:Version})
Conflicts: libkipi8
Recommends: graphicsmagick-imagemagick-compat (>= 1.1.7) | imagemagick (>= 5.4.8), konqueror, hugin, enblend, enfuse
Suggests: gallery, gimp, kmail, vorbis-tools
Enhances: digikam, gwenview, kphotoalbum, showimg
Description: image manipulation/handling plugins for KIPI aware programs
 KIPI plugins (KDE Image Plugin Interface) is an effort to develop a
 common plugin structure for Digikam, KPhotoAlbum (formerly known as
 KimDaBa), Showimg and Gwenview.
 Its aim is to share image plugins among graphic applications.
 .
 Current plugins ported to Qt4/KDE4:
 .
  AcquireImages      : acquire images using flat scanner
  Calendar           : create calendars
  DngConverter       : convert Raw Image to Digital NeGative
  Facebook           : import/export images to/from a remote Facebook
  FlickrExport       : export images to a remote Flickr based web service
  GalleryExport      : export images to a remote Gallery (and Gallery 2)
  GPSSync            : geolocalize pictures
  HTMLExport         : export images collections into a static XHTML page
  ImageViewer        : preview images using OpenGL
  JpegLossLess       : rotate/flip images without losing quality
  MetadataEdit       : edit EXIF, IPTC and XMP metadata
  PicasaWebExport    : export images to a remote Picasa web service
  PrintImage         : print images in various format
  RawConverter       : convert Raw Image to JPEG/PNG/TIFF
  RemoveRedEyes      : remove red eyes on image automatically
  SendImages         : send images by e-mail
  SimpleViewerExport : export images to Flash using SimpleViewer
  SlideShow          : Slide images with 2D and 3D effects using OpenGL
  Smug               : import/export images to/from a remote SmugMug
  TimeAdjust         : adjust date and time
  IpodExport         : export pictures to an Ipod device
  BatchProcess       : batch process images (convert, resize, rename, etc.)
  KIOExport          : export images to remote computer using network protocol
  Shwup              : export images to Shwup web service
  ExpoBlending       : create pseudo HDR image with a stack of bracketed images
  PiwigoExport       : export images to a remote Piwigo 
  DebianScreenshots  : export images to Debian Screenshots web service
  Kopete             : export images to an instant messaging contact
  YandexFotki        : export images to Yandex web service
  MediaWiki          : export images to Mediawiki based web service
  RajceExport        : export images to Rajce web service
  Vkontakte          : export images to VKontakte web service
  PhotoLayoutEditor  : assemble images together
 .
 Porting under progress to Qt4/KDE4:
 .
  WallPaper          : set image as background on your desktop
 .
 Not yet ported to Qt4/KDE4:
 .
  CDArchiving        : archive your image collections to a CD or DVD
  MpegEncoder        : create an MPEG slideshow with a set of images

Package: kipi-plugins-common
Architecture: all
Section: graphics
Depends: ${misc:Depends}
Description: kipi-plugins architecture-independent data
 The architecture independent data needed for the kipi-plugins package.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

#  * digikam 2.0.0 uses features from kdegraphics 4.6 ships a private 
#  version of the kdegraphics libs - this is not the Debian way :-(
#
# The following may work with KDE SC 4.7 :-)
#
#override_dh_auto_configure:
#	dh_auto_configure -- -DWANT_NORPATH:BOOL=1 -DDIGIKAMSC_USE_PRIVATE_KDEGRAPHICS:BOOL=0

override_dh_installchangelogs:
	dh_installchangelogs core/ChangeLog 

override_dh_install:
	dh_install --fail-missing

override_dh_strip:
	dh_strip -a --dbg-package=digikam-dbg

	# fix binary-or-shlib-defines-rpath
	chrpath -d debian/digikam/usr/lib/kde4/*.so debian/digikam/usr/lib/*.so.*
